function frequentPatterns = directedSequenceMining(data, sMin)

frequentPatterns = patternSearch(data, sMin, @initializeWords, @expandSequences, @findSupport, @sortAlphabet, @prune);

% for directed sequences, initialization consists of creating a list
% containing the empty sequence
function emptyWordArray = initializeWords(sortedAlphabet)
emptyWord.sequence = {};
emptyWordArray = {emptyWord};

% This function should be implemented by students.
% - Cell arrays oldPatterns and nextPatterns shoukd have the same structure:
%   they should contain structures with only one item: "sequence".
% - This is an example how to construct such a structure:
%       str1.sequence = {'a', 'b'}; //i.e. str1 is a pattern ab
% - Cell array alphabet contains symbols from the alphabet used in the
%   sequence and it is lexicographically sorted.
function nextPatterns = expandSequences(oldPatterns, alphabet)


% This function computes support
% - Structure "pattern" has only one item: "sequence".
% - The function should return support of "pattern" as described in the
%   assignment for this lecture.
function support = findSupport(pattern, data)

% naimplementovano naivne, efektivneji napr. Boyer-Moore algoritmus
support = 0;
if isempty(pattern.sequence)
    support = size(data.sequence,2)-size(pattern.sequence,2)+1;
else
    patternsize = size(pattern.sequence,2);
    for i = 1:(size(data.sequence,2)-size(pattern.sequence,2)+1)
        for j = 1:patternsize
            if data.sequence{i+j-1} ~= pattern.sequence{j}
                break;
            end
            if j == patternsize
                support = support+1;
            end
        end
    end
end
support = support / (size(data.sequence,2)-size(pattern.sequence,2)+1);

function sortedAlphabet = sortAlphabet(data)
sortedAlphabet = sort(unique(data.sequence));

function filtered = prune(shorter, longer)
filtered = {};
for i = 1:size(longer, 2)
    tested = longer{i};
    for j = 1:size(shorter, 2)
        if cellEq(tested.sequence(2:end),shorter{j}.sequence)
            filtered{end+1} = tested;
            break;
        end
    end
end

function out = cellEq(a,b)
out = 1;
for i = 1:size(a,2)
    if a{i} ~= b{i}
       out = 0;
       break;
    end
end