function freqPatterns = aprioriFPM(data, sMin, initializeWords, expandWords, findSupport, sortedAlphabet, prune)
% original code created by Jan Hrdlicka, changed by OK (potential errors most likely OK's)
% data is a structure, sMin is minimum support, initializeWords,
% expandWords and findSupport are function handles

% frequent patterns should be stored here
freqPatterns = {};

% we construct a sorted cell array of used symbols
sortedA = sortedAlphabet(data);
% first, we construct the smallest necessary words ({}, i.e. an empty word is considered valid)
words0 = initializeWords(sortedA);

% we select only the frequent words from "words0" and store them to "words"
words = {};
for i = 1:size(words0,2)
    s = findSupport(words0{i}, data);
    words0{i}.support = s;
    if s >= sMin
        words{end+1} = words0{i};
    end
end

% we repeat this loop as long as new frequent patterns are found
while ~isempty(words)
    for i = 1:size(words,2)
        freqPatterns{end+1} = words{i};
    end
    % new words
    wordCand = expandWords(words,sortedA);
    wordCand = prune(words, wordCand);
    
    words = {};
    % we select only the frequent ones
    for i = 1:length(wordCand)
        s = findSupport(wordCand{i},data);
        wordCand{i}.support = s;
        if s>=sMin
            words{end+1} = wordCand{i};
        end
    end
end